#
# spec file for package qbe
#
# Copyright (c) 2024 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           qbe
Version:        1.2
Release:        1.3
Summary:        Small embeddable C compiler backend
Group:          Development/Tools/Building
URL:            https://c9x.me/compile
Source0:        https://c9x.me/compile/release/qbe-%{version}.tar.xz
BuildRequires:  zstd
License:        MIT

%description
QBE is a compiler backend that aims to provide 70% of the
performance of industrial optimizing compilers in 10% of the code.
QBE fosters language innovation by offering a compact user-friendly
and performant backend.

The size limit constrains QBE to focus on the essential and
prevents embarking on a never-ending path of diminishing returns.

%prep
%setup -q -n %{name}-%{version}

%build
export CC="cc"
%make_build CFLAGS="%optflags -std=c99 -fPIE"

%install
%make_install PREFIX="%_prefix"

%files
%{_bindir}/%{name}
%license LICENSE
%doc README doc

%changelog
* Sat Feb 17 2024 Soc Virnyl Estela <uncomfy+openbuildservice@uncomfyhalomacro.pl>
- Update to version 1.2
  * Print total number of tests run to get a better view of how much is broken.
* Sat Jan 20 2024 Soc Virnyl Estela <uncomfy+openbuildservice@uncomfyhalomacro.pl>
- Update to version v1.1+30:
  * fix link in doc
  * dbgloc: add column argument
  * Add missing documentation for union types and VAL.
  * revert 5af33410
  * Fix IBT/BTI by instrumenting function calls
  * hard-code $(CC) to equal "cc"
* Fri Nov 10 2023 Soc Virnyl Estela <uncomfy+openbuildservice@uncomfyhalomacro.pl>
- Update Groups section in specfile
* Fri Nov 10 2023 socvirnyl.estela@gmail.com
- Update to version v1.1+24:
  * Fix architecture detection on OpenBSD/arm64
  * comments in amd64 isel
  * Fix conversion from float/double to unsigned int
  * test.sh fixes for devuan linux
  * file,loc become dbgfile,dbgloc
  * parseline() tweaks
  * implement line number info tracking
  * Bump NString
  * fix sub-word returns on arm64_apple
  * Fix 1 C UB
* Sun Feb  5 2023 Soc Virnyl Estela <socvirnyl.estela@gmail.com>
- Update to version 1.1:
  * Improvements on performance and expressiveness
  * support for Apple ARM-based hardware (arm64_apple target);
  * support for thread-local storage;
  * a new blit instruction to copy small aggregates;
  * a new hlt instruction to flag non-termination;
  * a new stack slot coalescing optimization.
* Tue Jan 31 2023 Soc Virnyl Estela <socvirnyl.estela@gmail.com>
- Remove BuildRequires since c_compiler, glibc, and glibc-devel are
  pulled in the vm during buildtime.
* Sat Jan 28 2023 Soc Virnyl Estela <socvirnyl.estela@gmail.com>
- Initial spec for qbe 1.0
